# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import popuplib
import playerlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

_all_    = ['Kick','Ban']
_alive_  = ['Slay','Freeze','Noclip','Godmode']
_dead_   = []
_others_ = ['Unban','Mute','Move Players','Respawn']

sort = ['a_Kick','b_Ban','c_Unban','d_Move Players','e_Mute','f_Slay','g_Respawn','h_Freeze','i_Noclip','j_Godmode']
sort.sort()

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Loads ###
	for x in (_all_,_alive_,_dead_,_others_):
		for item in x: es.load('sam/base/pcontrol/' + item.replace(' ','').lower())

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unloads ###
	for x in (_all_,_alive_,_dead_,_others_):
		for item in x: es.unload('sam/base/pcontrol/' + item.replace(' ','').lower())

	### Popups ###
	func.popupDelete('pcontrol')
	func.popupDelete('getTarget')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def modulePopup(userid):
	func.popupDelete('pcontrol')
	popup = popuplib.easymenu('pcontrol', None, function)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: %s' % func.lang_titles('pcontrol_name'))
	for item in sort:
		lang = item.replace('%s_' % item[0],'').replace(' ','').lower()
		popup.addoption(item.replace('%s_' % item[0],''), func.lang_titles('pcontrol_%s' % lang))
	popup.submenu(10, 'mainPage')
	popup.send(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def function(userid, item, popup):
	if admins.checkAccess(es.getplayersteamid(userid), item):
		name = item.replace(' ','').lower()
		if not item in _others_:
			func.popupDelete('getTarget')
			popup = popuplib.easymenu('getTarget', None, gotoFunc)
			popup.c_beginsep = func.pline
			popup.c_pagesep  = func.pline
			popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
			popup.setdescription('\n \n :: %s\n # %s'%(func.lang_titles('pcontrol_%s' % name),func.lang_titles('pcontrol_%s_desc' % name)))
			popup.submenu(10, 'pcontrol')
			if item in _all_:
				for ply in playerlib.getPlayerList('#all'): popup.addoption({'target':ply,'func':name}, ply.name)
				popup.send(userid)
			elif item in _alive_:
				alive = playerlib.getPlayerList('#alive')
				if len(alive) > 0:
					for ply in alive: popup.addoption({'target':ply,'func':name}, ply.name)
					popup.send(userid)
				else:
					func.hudhint(userid, func.lang_pcontrol('no_alive_players'))
					modulePopup(userid)
			elif item in _dead_:
				dead  = playerlib.getPlayerList('#dead')
				_list = []
				for x in dead:
					if x.team != 1: _list.append(x)
				if len(_list) > 0:
					for ply in _list: popup.addoption({'target':ply,'func':name}, ply.name)
					popup.send(userid)
				else:
					func.hudhint(userid, func.lang_pcontrol('no_dead_players'))
					modulePopup(userid)
		else: sendToOthers(userid, name)
	else: modulePopup(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def gotoFunc(userid, info, popup):
	block = es.import_addon('sam/base/pcontrol/%s' % info['func'])
	block.moduleAction(playerlib.getPlayer(userid),playerlib.getPlayer(info['target']))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def sendToOthers(userid, name):
	block = es.import_addon('sam/base/pcontrol/%s' % name)
	block.moduleAction(userid)

# ============================================================================================================================================================= #